import { resolveComponent as h, openBlock as o, createElementBlock as n, createBlock as d, createCommentVNode as u, Fragment as m, renderList as g, toDisplayString as c } from "vue";
import { _ as f } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
const v = {
  props: {
    modelValue: {
      type: [Number, String],
      default: 1
    },
    itemsPerPage: {
      type: Number,
      default: 10
    },
    totalPages: {
      type: Number,
      required: !0
    },
    maxVisiblePages: {
      type: Number,
      default: 5,
      validator: (e) => e % 2 === 1
    },
    showArrows: {
      type: Boolean,
      default: !0
    },
    showInfo: {
      type: Boolean,
      default: !0
    }
  },
  computed: {
    parsedModelValue() {
      return parseInt(this.modelValue, 10);
    },
    visiblePages() {
      const e = (this.maxVisiblePages - 1) / 2, l = [];
      return this.totalPages <= this.maxVisiblePages ? Array.from(Array(this.totalPages)).forEach((a, t) => {
        l.push(t + 1);
      }) : this.parsedModelValue <= e ? Array.from(Array(this.maxVisiblePages)).forEach((a, t) => {
        l.push(t + 1);
      }) : this.parsedModelValue > e && this.parsedModelValue < this.totalPages - e ? (Array.from(Array(e)).forEach((a, t) => {
        l.push(this.parsedModelValue - (t + 1));
      }), l.push(this.parsedModelValue), Array.from(Array(e)).forEach((a, t) => {
        l.push(this.parsedModelValue + (t + 1));
      })) : Array.from(Array(this.maxVisiblePages)).forEach((a, t) => {
        l.push(this.totalPages - t);
      }), l.sort((a, t) => a - t);
    },
    hasOverflow() {
      const e = this.visiblePages.includes(this.totalPages - 1);
      return this.totalPages - this.visiblePages.length > 1 && !e;
    }
  },
  emits: ["update:modelValue"],
  methods: {
    onClick(e) {
      this.$emit("update:modelValue", e);
    },
    onClickPrev() {
      this.$emit("update:modelValue", this.parsedModelValue - 1);
    },
    onClickNext() {
      this.$emit("update:modelValue", this.parsedModelValue + 1);
    }
  }
}, p = { class: "lv-pagination" }, _ = {
  key: 2,
  class: "lv-pagination__info"
};
function b(e, l, a, t, P, s) {
  const i = h("lv-button");
  return o(), n("div", p, [
    a.showArrows ? (o(), d(i, {
      key: 0,
      icon: "chevron-left",
      color: "ghost-default",
      disabled: s.parsedModelValue === 1,
      onClick: s.onClickPrev,
      class: "lv-pagination__button"
    }, null, 8, ["disabled", "onClick"])) : u("", !0),
    (o(!0), n(m, null, g(s.visiblePages, (r) => (o(), d(i, {
      key: r,
      label: r.toString(),
      color: r === s.parsedModelValue ? "solid-primary" : "ghost-default",
      onClick: (V) => s.onClick(r),
      class: "lv-pagination__button"
    }, null, 8, ["label", "color", "onClick"]))), 128)),
    a.showArrows ? (o(), d(i, {
      key: 1,
      icon: "chevron-right",
      color: "ghost-default",
      disabled: s.parsedModelValue === a.totalPages,
      onClick: s.onClickNext,
      class: "lv-pagination__button"
    }, null, 8, ["disabled", "onClick"])) : u("", !0),
    a.showInfo ? (o(), n("div", _, c(s.parsedModelValue) + "/" + c(a.totalPages), 1)) : u("", !0)
  ]);
}
const C = /* @__PURE__ */ f(v, [["render", b]]);
export {
  C as default
};
