import { resolveComponent as f, openBlock as s, createElementBlock as a, normalizeClass as P, createElementVNode as r, normalizeStyle as m, createBlock as d, withCtx as l, createTextVNode as h, toDisplayString as c, createCommentVNode as y, Fragment as p } from "vue";
import { _ as M } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
import { u } from "./index.673e51a0.mjs";
const T = {
  props: {
    min: {
      type: Number,
      default: 0
    },
    max: {
      type: Number,
      default: 100
    },
    modelValue: {
      type: Object,
      default: () => ({})
    },
    decimals: {
      type: Number,
      default: 0,
      validator: (e) => e >= 0
    },
    step: {
      type: Number,
      default: 1,
      validator: (e) => e > 0
    },
    invalid: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    loading: {
      type: Boolean,
      default: !1
    },
    showRange: {
      type: Boolean,
      default: !1
    },
    showPopover: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["update:modelValue"],
  data() {
    return {
      trackX: 0,
      trackWidth: 0,
      primaryPosition: 0,
      secondaryPosition: 0,
      draggingPrimary: !1,
      draggingSecondary: !1
    };
  },
  computed: {
    classNames() {
      return {
        "lv-range-slider--invalid": this.invalid,
        "lv-range-slider--disabled": this.disabled,
        "lv-range-slider--loading": this.loading
      };
    },
    primaryValue() {
      const e = (this.max - this.min) / 100 * this.primaryPosition + this.min;
      return parseFloat(e.toFixed(this.decimals));
    },
    secondaryValue() {
      const e = (this.max - this.min) / 100 * this.secondaryPosition + this.min;
      return parseFloat(e.toFixed(this.decimals));
    },
    indicatorLeft() {
      return this.primaryPosition <= this.secondaryPosition ? this.primaryPosition : this.secondaryPosition;
    },
    indicatorRight() {
      return this.primaryPosition >= this.secondaryPosition ? this.primaryPosition : this.secondaryPosition;
    },
    stepPercentage() {
      return 100 / (this.max - this.min) * this.step;
    },
    styleObjectIndicator() {
      return { left: `${this.indicatorLeft}%`, right: `${100 - this.indicatorRight}%` };
    },
    styleObjectThumbPrimary() {
      return { left: `${this.primaryPosition}%` };
    },
    styleObjectThumbSecondary() {
      return { left: `${this.secondaryPosition}%` };
    }
  },
  watch: {
    modelValue: {
      handler(e) {
        this.primaryPosition = e.from ? this.getPositionFromValue(e.from) : 0, this.secondaryPosition = e.to ? this.getPositionFromValue(e.to) : 100;
      },
      deep: !0,
      immediate: !0
    }
  },
  mounted() {
    this.cacheDimensions();
  },
  created() {
    this.onPrimaryMouseMoveThrottled = u(this.onPrimaryMouseMove, 24), this.onSecondaryMouseMoveThrottled = u(this.onSecondaryMouseMove, 24), this.onPrimaryTouchMoveThrottled = u(this.onPrimaryTouchMove, 24), this.onSecondaryTouchMoveThrottled = u(this.onSecondaryTouchMove, 24);
  },
  methods: {
    onPrimaryMouseDown(e) {
      this.draggingPrimary = !0, e.preventDefault(), !(this.disabled || this.loading) && (this.cacheDimensions(), document.addEventListener("mousemove", this.onPrimaryMouseMoveThrottled, !1), document.addEventListener("mouseup", this.onMouseUp, !1));
    },
    onPrimaryMouseMove(e) {
      this.primaryPosition = this.getRelativePosition(e.pageX);
    },
    onSecondaryMouseDown(e) {
      this.draggingSecondary = !0, e.preventDefault(), !(this.disabled || this.loading) && (this.cacheDimensions(), document.addEventListener("mousemove", this.onSecondaryMouseMoveThrottled, !1), document.addEventListener("mouseup", this.onMouseUp, !1));
    },
    onSecondaryMouseMove(e) {
      this.secondaryPosition = this.getRelativePosition(e.pageX);
    },
    onMouseUp() {
      this.draggingPrimary = !1, this.draggingSecondary = !1, document.removeEventListener("mousemove", this.onPrimaryMouseMoveThrottled, !1), document.removeEventListener("mousemove", this.onSecondaryMouseMoveThrottled, !1), document.removeEventListener("mouseup", this.onMouseUp, !1), this.emitInputEvent();
    },
    onPrimaryTouchStart() {
      this.disabled || (this.cacheDimensions(), document.addEventListener("touchmove", this.onPrimaryTouchMoveThrottled), document.addEventListener("touchend", this.onTouchEnd));
    },
    onPrimaryTouchMove(e) {
      e.preventDefault(), this.primaryPosition = this.getRelativePosition(e.touches[0].clientX);
    },
    onSecondaryTouchStart() {
      this.disabled || (this.cacheDimensions(), document.addEventListener("touchmove", this.onSecondaryTouchMoveThrottled), document.addEventListener("touchend", this.onTouchEnd));
    },
    onSecondaryTouchMove(e) {
      e.preventDefault(), this.secondaryPosition = this.getRelativePosition(e.touches[0].clientX);
    },
    onTouchEnd() {
      document.removeEventListener("touchmove", this.onPrimaryTouchMoveThrottled), document.removeEventListener("touchmove", this.onSecondaryTouchMoveThrottled), document.removeEventListener("touchend", this.onTouchEnd), this.emitInputEvent();
    },
    emitInputEvent() {
      const e = this.primaryValue <= this.secondaryValue ? this.primaryValue : this.secondaryValue, i = this.primaryValue <= this.secondaryValue ? this.secondaryValue : this.primaryValue;
      this.$emit("update:modelValue", {
        from: e,
        to: i
      });
    },
    cacheDimensions() {
      this.trackWidth = this.$refs.track.offsetWidth, this.trackX = this.$refs.track.getBoundingClientRect().left;
    },
    getPositionFromValue(e) {
      return 100 / (this.max - this.min) * e - this.min / (this.max - this.min) * 100;
    },
    getRelativePosition(e) {
      let o = (e - this.trackX) / this.trackWidth * 100;
      return this.step && (o = Math.round(o / this.stepPercentage) * this.stepPercentage), o = Math.min(Math.max(o, 0), 100), o;
    }
  }
}, S = { class: "lv-range-slider__track" }, b = {
  ref: "track",
  class: "lv-range-slider__track-boundaries"
}, V = /* @__PURE__ */ r("div", { class: "lv-range-slider__thumb-hit-area" }, null, -1), E = /* @__PURE__ */ r("div", { class: "lv-range-slider__thumb-hit-area" }, null, -1), k = {
  key: 0,
  class: "lv-range-slider__range"
}, w = { class: "lv-range-slider__range-value lv-range-slider__range-value--primary" }, L = { class: "lv-range-slider__range-value lv-range-slider__range-value--secondary" };
function x(e, i, o, D, v, t) {
  const g = f("lv-popover"), _ = f("lv-icon");
  return s(), a("div", {
    class: P(["lv-range-slider", t.classNames])
  }, [
    r("div", S, [
      r("div", b, [
        r("div", {
          class: "lv-range-slider__indicator",
          style: m(t.styleObjectIndicator)
        }, null, 4),
        r("div", {
          ref: "primary",
          class: "lv-range-slider__thumb lv-range-slider__thumb--primary",
          style: m(t.styleObjectThumbPrimary),
          onMousedown: i[0] || (i[0] = (...n) => t.onPrimaryMouseDown && t.onPrimaryMouseDown(...n)),
          onTouchstart: i[1] || (i[1] = (...n) => t.onPrimaryTouchStart && t.onPrimaryTouchStart(...n))
        }, [
          o.showPopover ? (s(), d(g, {
            key: 0,
            show: v.draggingPrimary,
            placement: "top",
            trigger: "manual",
            padding: ".25rem"
          }, {
            reference: l(() => [
              V
            ]),
            content: l(() => [
              h(c(t.primaryValue), 1)
            ]),
            _: 1
          }, 8, ["show"])) : y("", !0)
        ], 36),
        r("div", {
          ref: "secondary",
          class: "lv-range-slider__thumb lv-range-slider__thumb--secondary",
          style: m(t.styleObjectThumbSecondary),
          onMousedown: i[2] || (i[2] = (...n) => t.onSecondaryMouseDown && t.onSecondaryMouseDown(...n)),
          onTouchstart: i[3] || (i[3] = (...n) => t.onSecondaryTouchStart && t.onSecondaryTouchStart(...n))
        }, [
          o.showPopover ? (s(), d(g, {
            key: 0,
            show: v.draggingSecondary,
            placement: "top",
            trigger: "manual",
            padding: ".25rem"
          }, {
            reference: l(() => [
              E
            ]),
            content: l(() => [
              h(c(t.secondaryValue), 1)
            ]),
            _: 1
          }, 8, ["show"])) : y("", !0)
        ], 36)
      ], 512)
    ]),
    o.showRange ? (s(), a("div", k, [
      r("div", w, [
        o.loading ? (s(), d(_, {
          key: 0,
          class: "lv-range-slider__loader",
          size: 12,
          name: "loader-2"
        })) : (s(), a(p, { key: 1 }, [
          h(c(t.primaryValue.toFixed(o.decimals)), 1)
        ], 64))
      ]),
      r("div", L, [
        o.loading ? (s(), d(_, {
          key: 0,
          class: "lv-range-slider__loader",
          size: 12,
          name: "loader-2"
        })) : (s(), a(p, { key: 1 }, [
          h(c(t.secondaryValue.toFixed(o.decimals)), 1)
        ], 64))
      ])
    ])) : y("", !0)
  ], 2);
}
const N = /* @__PURE__ */ M(T, [["render", x]]);
export {
  N as default
};
