import { o as k } from "./index.104c9c16.mjs";
import { computed as r, resolveComponent as V, openBlock as t, createElementBlock as i, normalizeClass as w, withKeys as p, createElementVNode as v, withModifiers as g, renderSlot as d, createTextVNode as _, toDisplayString as c, withDirectives as u, vModelText as b, Fragment as x, renderList as O, createCommentVNode as m, createBlock as f, createVNode as S, Transition as C, withCtx as B, vShow as T } from "vue";
import { p as E } from "./propSizeMixin.5222687c.mjs";
import { _ as N } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
import "./index.673e51a0.mjs";
const z = {
  provide() {
    return {
      value: r(() => this.value),
      multiple: r(() => this.multiple),
      searchable: r(() => this.searchable),
      clearable: r(() => this.clearable),
      searchValue: r(() => this.search),
      visibleOptions: r(() => this.visibleOptions)
    };
  },
  mixins: [E()],
  props: {
    value: {
      type: [Object, Array],
      default: null
    },
    multiple: {
      type: Boolean,
      default: !1
    },
    placeholder: {
      type: String,
      default: "Choose an option"
    },
    searchable: {
      type: Boolean,
      default: !1
    },
    clearable: {
      type: Boolean,
      default: !0
    },
    loading: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    teleportTarget: {
      type: String,
      default: "body"
    }
  },
  data() {
    return {
      dropdownVisible: !1,
      focusedOptionIndex: null,
      search: null,
      visibleOptions: null,
      mounted: !1
    };
  },
  computed: {
    focusTrapOptions() {
      return {
        immediate: !0,
        escapeDeactivates: !1,
        fallbackFocus: document.body
      };
    },
    hasValue() {
      return !!(this.multiple && this.value.length > 0 || !this.multiple && this.value);
    },
    classObject() {
      return {
        [`lv-select--size-${this.size}`]: !0,
        "lv-select--disabled": !!this.disabled || !!this.loading,
        "lv-select--loading": !!this.loading
      };
    }
  },
  watch: {
    search(a) {
      !this.dropdownVisible && a && (this.dropdownVisible = !0);
    },
    value(a) {
      !this.multiple && this.dropdownVisible && (this.dropdownVisible = !1), a && this.search && (this.search = null);
    }
  },
  mounted() {
    this.mounted = !0, this.visibleOptions = this.getVisibleOptions(), k(this.$refs.select, () => {
      this.dropdownVisible = !1;
    });
  },
  updated() {
    this.$nextTick(() => {
      this.visibleOptions = this.getVisibleOptions();
    });
  },
  methods: {
    getVisibleOptions() {
      return this.$el.querySelectorAll(".lv-select-option").length;
    },
    onClickSelection() {
      this.dropdownVisible = !this.dropdownVisible;
    },
    onEscape() {
      this.dropdownVisible = !1;
    }
  }
}, j = ["aria-expanded"], D = {
  key: 0,
  class: "lv-select__value"
}, K = ["placeholder"], L = {
  key: 2,
  class: "lv-select__placeholder"
}, M = {
  key: 1,
  class: "lv-select__value"
}, A = ["placeholder"], F = {
  key: 2,
  class: "lv-select__placeholder"
}, U = {
  class: "lv-select__dropdown",
  role: "listbox"
}, q = {
  key: 0,
  class: "lv-select__no-options"
};
function I(a, s, e, G, n, o) {
  const h = V("lv-icon");
  return t(), i("div", {
    ref: "select",
    class: w(["lv-select", o.classObject]),
    role: "combobox",
    "aria-expanded": n.dropdownVisible,
    "aria-haspopup": "listbox",
    onKeydown: s[4] || (s[4] = p((...l) => o.onEscape && o.onEscape(...l), ["esc"]))
  }, [
    v("div", {
      ref: "combobox",
      class: "lv-select__input",
      tabindex: "0",
      onClick: s[2] || (s[2] = (...l) => o.onClickSelection && o.onClickSelection(...l)),
      onKeydown: s[3] || (s[3] = p(g((...l) => o.onClickSelection && o.onClickSelection(...l), ["prevent"]), ["enter", "space"]))
    }, [
      e.multiple ? e.multiple ? (t(), i("div", M, [
        o.hasValue ? (t(!0), i(x, { key: 0 }, O(e.value, (l, y) => (t(), i("span", {
          key: y,
          class: "lv-select__value-item"
        }, [
          d(a.$slots, "value", {
            values: e.value,
            value: l
          }, () => [
            _(c(l.label), 1)
          ])
        ]))), 128)) : e.searchable ? u((t(), i("input", {
          key: 1,
          "onUpdate:modelValue": s[1] || (s[1] = (l) => n.search = l),
          class: "lv-select__search",
          type: "text",
          placeholder: e.placeholder
        }, null, 8, A)), [
          [b, n.search]
        ]) : (t(), i("div", F, c(e.placeholder), 1))
      ])) : m("", !0) : (t(), i("div", D, [
        o.hasValue ? d(a.$slots, "value", {
          key: 0,
          value: e.value
        }, () => [
          _(c(e.value.label), 1)
        ]) : e.searchable ? u((t(), i("input", {
          key: 1,
          "onUpdate:modelValue": s[0] || (s[0] = (l) => n.search = l),
          class: "lv-select__search",
          type: "text",
          placeholder: e.placeholder
        }, null, 8, K)), [
          [b, n.search]
        ]) : (t(), i("div", L, c(e.placeholder), 1))
      ])),
      e.loading ? (t(), f(h, {
        key: 2,
        class: "lv-select__loading",
        name: "loader-2"
      })) : (t(), f(h, {
        key: 3,
        class: "lv-select__icon",
        name: "chevron-down"
      }))
    ], 544),
    S(C, { name: "dropdown" }, {
      default: B(() => [
        u(v("div", U, [
          d(a.$slots, "default"),
          n.visibleOptions ? m("", !0) : (t(), i("div", q, "No options found"))
        ], 512), [
          [T, n.dropdownVisible]
        ])
      ]),
      _: 3
    })
  ], 42, j);
}
const W = /* @__PURE__ */ N(z, [["render", I]]);
export {
  W as default
};
