import { resolveComponent as m, openBlock as i, createElementBlock as a, normalizeClass as T, createElementVNode as o, normalizeStyle as c, withModifiers as y, createBlock as r, withCtx as v, createTextVNode as d, toDisplayString as h, createCommentVNode as _, Fragment as g } from "vue";
import { _ as M } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
import { u as b } from "./index.673e51a0.mjs";
const k = {
  props: {
    min: {
      type: Number,
      default: 0
    },
    max: {
      type: Number,
      default: 100
    },
    modelValue: {
      type: Number,
      default: 0
    },
    decimals: {
      type: Number,
      default: 0,
      validator: (e) => e >= 0
    },
    step: {
      type: Number,
      default: 1,
      validator: (e) => e > 0
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    loading: {
      type: Boolean,
      default: !1
    },
    showRange: {
      type: Boolean,
      default: !1
    },
    showPopover: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["update:modelValue"],
  data() {
    return {
      dragging: !1,
      trackX: 0,
      trackWidth: 0,
      thumbPosition: 0
    };
  },
  computed: {
    classNames() {
      return {
        "lv-slider--invalid": this.invalid,
        "lv-slider--disabled": this.disabled,
        "lv-slider--loading": this.loading
      };
    },
    parsedValue() {
      const e = (this.max - this.min) / 100 * this.thumbPosition + this.min;
      return parseFloat(e.toFixed(this.decimals));
    },
    indicatorRight() {
      return this.thumbPosition;
    },
    stepPercentage() {
      return 100 / (this.max - this.min) * this.step;
    },
    styleObjectIndicator() {
      return { left: 0, right: `${100 - this.indicatorRight}%` };
    },
    styleObjectThumb() {
      return { left: `${this.thumbPosition}%` };
    }
  },
  watch: {
    modelValue: {
      handler(e) {
        this.thumbPosition = e ? this.getPositionFromValue(e) : 100;
      },
      deep: !0,
      immediate: !0
    }
  },
  mounted() {
    this.cacheDimensions();
  },
  created() {
    this.onThumbMouseMoveThrottled = b(this.onThumbMouseMove, 25, !1), this.onThumbTouchMoveThrottled = b(this.onThumbTouchMove, 25, !1);
  },
  methods: {
    onThumbMouseDown() {
      this.disabled || this.loading || (this.dragging = !0, this.cacheDimensions(), document.addEventListener("mousemove", this.onThumbMouseMoveThrottled, !1), document.addEventListener("mouseup", this.onMouseUp, !1));
    },
    onThumbMouseMove(e) {
      this.thumbPosition = this.getRelativePosition(e.pageX);
    },
    onMouseUp() {
      this.dragging = !1, document.removeEventListener("mousemove", this.onThumbMouseMoveThrottled, !1), document.removeEventListener("mouseup", this.onMouseUp, !1), this.emitInputEvent();
    },
    onThumbTouchStart() {
      this.disabled || (this.cacheDimensions(), document.addEventListener("touchmove", this.onThumbTouchMoveThrottled), document.addEventListener("touchend", this.onTouchEnd));
    },
    onThumbTouchMove(e) {
      e.preventDefault(), this.thumbPosition = this.getRelativePosition(e.touches[0].clientX);
    },
    onTouchEnd() {
      document.removeEventListener("touchmove", this.onThumbTouchMoveThrottled), document.removeEventListener("touchend", this.onTouchEnd), this.emitInputEvent();
    },
    emitInputEvent() {
      this.$emit("update:modelValue", this.parsedValue);
    },
    cacheDimensions() {
      this.trackWidth = this.$refs.track.offsetWidth, this.trackX = this.$refs.track.getBoundingClientRect().left;
    },
    getPositionFromValue(e) {
      return 100 / (this.max - this.min) * e - this.min / (this.max - this.min) * 100;
    },
    getRelativePosition(e) {
      let t = (e - this.trackX) / this.trackWidth * 100;
      return this.step && (t = Math.round(t / this.stepPercentage) * this.stepPercentage), t = Math.min(Math.max(t, 0), 100), t;
    }
  }
}, P = { class: "lv-slider__track" }, x = {
  ref: "track",
  class: "lv-slider__track-boundaries"
}, E = /* @__PURE__ */ o("div", { class: "lv-range-slider__thumb-hit-area" }, null, -1), w = {
  key: 0,
  class: "lv-slider__range"
}, V = { class: "lv-slider__range-value lv-slider__range-value--primary" }, L = { class: "lv-slider__range-value lv-slider__range-value--secondary" };
function N(e, n, t, D, f, s) {
  const p = m("lv-popover"), u = m("lv-icon");
  return i(), a("div", {
    class: T(["lv-slider", s.classNames])
  }, [
    o("div", P, [
      o("div", x, [
        o("div", {
          class: "lv-slider__indicator",
          style: c(s.styleObjectIndicator)
        }, null, 4),
        o("div", {
          class: "lv-slider__thumb lv-slider__thumb",
          style: c(s.styleObjectThumb),
          onMousedown: n[0] || (n[0] = y((...l) => s.onThumbMouseDown && s.onThumbMouseDown(...l), ["prevent"])),
          onTouchstart: n[1] || (n[1] = (...l) => s.onThumbTouchStart && s.onThumbTouchStart(...l))
        }, [
          t.showPopover ? (i(), r(p, {
            key: 0,
            show: f.dragging,
            placement: "top",
            trigger: "manual",
            padding: ".25rem"
          }, {
            reference: v(() => [
              E
            ]),
            content: v(() => [
              d(h(s.parsedValue), 1)
            ]),
            _: 1
          }, 8, ["show"])) : _("", !0)
        ], 36)
      ], 512)
    ]),
    t.showRange ? (i(), a("div", w, [
      o("div", V, [
        t.loading ? (i(), r(u, {
          key: 0,
          class: "lv-slider__loader",
          size: 12,
          name: "loader-2"
        })) : (i(), a(g, { key: 1 }, [
          d(h(t.min.toFixed(t.decimals)), 1)
        ], 64))
      ]),
      o("div", L, [
        t.loading ? (i(), r(u, {
          key: 0,
          class: "lv-slider__loader",
          size: 12,
          name: "loader-2"
        })) : (i(), a(g, { key: 1 }, [
          d(h(t.max.toFixed(t.decimals)), 1)
        ], 64))
      ])
    ])) : _("", !0)
  ], 2);
}
const S = /* @__PURE__ */ M(k, [["render", N]]);
export {
  S as default
};
